#include "microlib.h"
#include <sdl.h>
#include "zx.h"
extern int emu_running;
extern char globalpath[247];
SDL_Surface* surface;
SDL_Surface* monitor;
static volatile unsigned char palette_red[256];
static volatile unsigned char palette_green[256];
static volatile unsigned char palette_blue[256];
extern int full_screen;                  
extern int keyboard_on;
extern Uint8 last_keystates[SDLK_LAST];
extern int program_mode;
extern int key_to_map;
extern int map_keys[14];
volatile unsigned short        *memregs16;
         
unsigned char  *gp2x_screen;
unsigned int key_pairs[41*2] = 
{
		SPECKEY_0, SDLK_0, 
		SPECKEY_1, SDLK_1,
		SPECKEY_2, SDLK_2,
		SPECKEY_3, SDLK_3,
		SPECKEY_4, SDLK_4,
		SPECKEY_5, SDLK_5,		    
		SPECKEY_6, SDLK_6,
		SPECKEY_7, SDLK_7,
		SPECKEY_8, SDLK_8,
		SPECKEY_9, SDLK_9,
		SPECKEY_A, SDLK_a,
		SPECKEY_B, SDLK_b,		    
		SPECKEY_C, SDLK_c, 
		SPECKEY_D, SDLK_d, 
		SPECKEY_E, SDLK_e, 
		SPECKEY_F, SDLK_f, 
		SPECKEY_G, SDLK_g, 
		SPECKEY_H, SDLK_h,		    
		SPECKEY_I, SDLK_i, 
		SPECKEY_J, SDLK_j, 
		SPECKEY_K, SDLK_k, 
		SPECKEY_L, SDLK_l, 
		SPECKEY_M, SDLK_m, 
		SPECKEY_N, SDLK_n,		
		SPECKEY_O, SDLK_o, 
		SPECKEY_P, SDLK_p, 
		SPECKEY_Q, SDLK_q, 
		SPECKEY_R, SDLK_r, 
		SPECKEY_S, SDLK_s, 
		SPECKEY_T, SDLK_t,		
		SPECKEY_U, SDLK_u, 
		SPECKEY_V, SDLK_v, 
		SPECKEY_W, SDLK_w, 
		SPECKEY_X, SDLK_x, 
		SPECKEY_Y, SDLK_y, 
		SPECKEY_Z, SDLK_z,		    
		SPECKEY_SPACE, SDLK_SPACE, 
		SPECKEY_ENTER, SDLK_RETURN,
		SPECKEY_SHIFT, SDLK_LSHIFT, 
		SPECKEY_SYMB, SDLK_LMETA, 
		SPECKEY_CTRL, SDLK_AT	
};
  
//OK 
void gp2x_set_palette_color (int red, int green, int blue, int i)
{ 
  if(i>255)return;
  palette_red[i]=red;
  palette_green[i]=green;
  palette_blue[i]=blue;
  
}

SDL_Color palette[256];
//OK 
void gp2x_set_palette(void)
{
  int i=0;  	
  
  for(i=0; i<=255; i++) {
		palette[i].r = palette_red[i];
		palette[i].g = palette_green[i];
		palette[i].b = palette_blue[i];
  }    
  SDL_SetPalette(surface, SDL_LOGPAL|SDL_PHYSPAL, &palette[0], 0, 256);
}

//OK
void gp2x_waitvsync(void)
{
 SDL_Delay(20);
}

void gp2x_set_scaling(int W, int H)
{
	W=W;
	H=H;
	SDL_UpdateRect(surface, 0,0, 320, 240);
}

void gp2x_flip(void)
{
	gp2x_screen=surface->pixels;
	//SDL_BlitSurface(monitor, NULL, surface, NULL);
	if (full_screen && emu_running && !keyboard_on)
		{
		SDL_UpdateRect(surface, 32,24, 256, 192);
		}
	else
		{
		SDL_UpdateRect(surface, 0,0, 320, 240);
		}
}

//no flip with externalbuffer
void gp2x_noflip_buffering(void)
{  	   
  gp2x_screen =surface->pixels;
      
  SDL_UpdateRect(surface, 0,0, 320, 240);
}

void remap_spec_key(int aSpecKey)
	{
	SDL_Event event;
	while(1)
		{
		while( !SDL_PollEvent( &event) )
			{
			gp2x_waitvsync();
			}
		switch(event.type)
			{
			case SDL_KEYUP:
				key_pairs[(aSpecKey*2)+1] = event.key.keysym.sym;
				continue;
			default:
				break;
			}
		}
	
	}

unsigned long gp2x_joystick_poll(void)
{
  unsigned long l=0;    
  int numkeys;
  int loop;
  Uint8 * keyStates;
  SDL_PumpEvents();
  keyStates =  SDL_GetKeyState(&numkeys);
  
  if((keyStates[SDLK_UP]))
   l |= GP2X_UP;  
  if((keyStates[SDLK_LEFT]))
   l |= GP2X_LEFT ;  
  if((keyStates[SDLK_DOWN]))
   l |= GP2X_DOWN;  
  if((keyStates[SDLK_RIGHT]))
   l |=  GP2X_RIGHT;     
   
   //leo GPIO-C     
  if((keyStates[map_keys[12]]))
   l |= GP2X_SELECT; 
   
    
  // virtual keyboard  is on and we are running
  if(keyboard_on != 0 && emu_running)
	  {
	  if(program_mode && key_to_map != -1 && !l)
	  		{
	  		int index = 0;
	  		while(index < numkeys)
	  			{
	  			if(keyStates[index])
	  				{
	  				key_pairs[(key_to_map*2)+1] = index;
	  				key_to_map = -1;
	  				program_mode = 0;
	  				break;
	  				}
	  			index++;
	  			}
	  		}
	 
	  if((keyStates[SDLK_RETURN]))
		  l |= GP2X_X;
	  if((keyStates[SDLK_SPACE]))
		  l |= GP2X_Y;
	  if((keyStates[map_keys[11]])||(keyStates[SDLK_F5]))
		  l |= GP2X_START ;

	  if(keyStates[SDLK_ASTERISK])
		  l |=  GP2X_L;
	  if(keyStates[SDLK_HASH] )
		  l |= GP2X_R;
	  }
  // Only running emu, then map start and A buttons
  else if(emu_running)
	  {	  
	  for(loop = 0;loop<41*2;loop+=2)
		  {
		  if(keyStates[key_pairs[loop+1]])
			  {
			  ZXKey(key_pairs[loop]);
			  }
		  }
	  
	  if((keyStates[map_keys[10]])||(keyStates[SDLK_F5]))
		  l |= GP2X_A;
	  if((keyStates[map_keys[11]]))
		  l |= GP2X_START ;  
	  }
  else // config scr or load screen
	  {
	  int mouseX;
	  int mouseY;
	  Uint8 buttonState = SDL_GetMouseState(&mouseX, &mouseY);
	  
	  if(buttonState & SDL_BUTTON(SDL_BUTTON_LEFT))
		  {
		  l |=  GP2X_X;
		  }
	  
	  if(keyStates[SDLK_LSHIFT] || keyStates[SDLK_RSHIFT])
		  {
		  if((keyStates[SDLK_LEFT]))
			  {
			  l = l&(65535-GP2X_LEFT);
			  l |= GP2X_L ;
			  }
		  if((keyStates[SDLK_RIGHT]))
			  {
			  l = l&(65535-GP2X_RIGHT);
			  l |= GP2X_R ;
			  }
		  }

	  if((keyStates[SDLK_RETURN]) ||(keyStates[SDLK_F5]) || (keyStates[SDLK_PERIOD]))
		  l |=  GP2X_X;  

	  if((keyStates[SDLK_SPACE]))
		  l |=  GP2X_Y ;

	  if(keyStates[SDLK_1] || keyStates[SDLK_ASTERISK])
		  l |=  GP2X_L;
	  if(keyStates[SDLK_3] || keyStates[SDLK_HASH] )
		  l |= GP2X_R;
	  }

  /*if((keyStates[SDLK_HASH]))
   l |= GP2X_Y;*/    

  return l;
}


unsigned long gp2x_timer_poll(void)
{
   return SDL_GetTicks();
}

//SOUND


extern void gp2x_start_sound(int , int, int);
int gp2x_open_sound(int rate, int bits, int stereo)
	{

gp2x_start_sound(rate, bits, stereo);
return 1;
}
extern void gp2x_stop_sound();
int gp2x_close_sound(){
	gp2x_stop_sound();
	return 1;
}
 
void gp2x_end(void)
{
 SDL_FreeSurface(monitor);
 SDL_Quit();

}
 
void gp2x_init()
{
  char pathstring[256];
  SDL_Init(SDL_INIT_VIDEO|SDL_INIT_JOYSTICK );
  surface = SDL_SetVideoMode(320,240, 8, 0);
  gp2x_screen=surface->pixels;//malloc(320*240*2);//(unsigned char *)mmap(0,  320*240*2, PROT_WRITE, MAP_SHARED, fb0fd, 0);
  sprintf(pathstring,"%s/saves/gp2xpectrum.bmp",globalpath);
  monitor = SDL_LoadBMP(pathstring);
  SDL_ShowCursor(0);
}


