// optim
#include <eikapp.h>
#include <e32base.h>
#include <sdlapp.h>
#include <eikenv.h>
#include <eikappui.h>
#include <eikapp.h>
#include <string.h>
#include <bautils.h>
#include <sys\time.h>

extern "C"	
	{
	extern int volume;
	void simpleWait(int thissec, int lim_time)
	{
		struct timeval tval;
		int sleep = 0;

		gettimeofday(&tval, 0);
		if(thissec != tval.tv_sec) tval.tv_usec+=1000000;

		sleep = lim_time - tval.tv_usec - 2000;
		if (sleep > 0) {
			User::AfterHighRes(sleep);
		}
	}

	////////////////////////////////
	
void logit(char* achar, int aval)
	{
	RDebug::Printf("LAPER: %s=%d", achar, aval);
	}

int	 remove(const char * filename)
	{
	TPtrC8 ptr((unsigned char*) filename);
	TFileName fname;
	fname.Copy(ptr);
	BaflUtils::DeleteFile(CEikonEnv::Static()->FsSession(), fname);
	return 1;
	}

int	 isFolder(const char * filename)
	{
	TBool folder = EFalse;
	TPtrC8 ptr((unsigned char*) filename);
	TFileName fname;
	fname.Copy(ptr);
	for(TInt loop = 0;loop<fname.Length();loop++)
		{
		if(fname[loop] == '/')
			fname[loop] = '\\';
		}
	
	TInt res = BaflUtils::IsFolder(CEikonEnv::Static()->FsSession(), fname, folder);
	
	return folder;
	}

void get_drives(char* drivelist)
	{
	RFs& fs = CEikonEnv::Static()->FsSession();
	TPtr8 ptr((unsigned char*) drivelist,26);
	TDriveList list;
	fs.DriveList(list);
	ptr.Copy(list);	
	}

	}
#include <unistd.h>
extern "C"
{
#include "vsnprintf.h"
}

FILE* mystdout = NULL;
FILE* mystderr = NULL;
class CSymbianApp : public CSDLApp {
public:
	CSymbianApp();
	~CSymbianApp();
#if defined (UIQ3)
	/**
	 * Returns the resource id to be used to declare the views supported by this UIQ3 app
	 * @return TInt, resource id
	 */
	TInt ViewResourceId();
#endif
	void PreInitializeAppL()
		{
#ifdef UIQ3
			mystdout = fopen("c:\\shared\\gp2xpectrum\\stdout.txt","w");
			mystderr = fopen("c:\\shared\\gp2xpectrum\\stderr.txt","w");
#else
			mystdout = fopen("c:\\data\\gp2xpectrum\\stdout.txt","w");
			mystderr = fopen("c:\\data\\gp2xpectrum\\stderr.txt","w");
#endif
			*stdout = *mystdout;
			*stderr = *mystderr;
		}

	TUid AppDllUid() const;

};

#ifdef EPOC_AS_APP
// this function is called automatically by the SymbianOS to deliver the new CApaApplication object
#if !defined (UIQ3) && !defined (S60V3)
EXPORT_C 
#endif
CApaApplication* NewApplication() {
	return new CSymbianApp;
}

#if defined (UIQ3) || defined (S60V3)
#include <eikstart.h>
// E32Main() contains the program's start up code, the entry point for an EXE.
GLDEF_C TInt E32Main() {
 	return EikStart::RunApplication(NewApplication);
}
#endif

#endif // EPOC_AS_APP

#if !defined (UIQ3) && !defined (S60V3)
GLDEF_C  TInt E32Dll(TDllReason) {
	return KErrNone;
}
#endif

CSymbianApp::CSymbianApp() 
{
}

CSymbianApp::~CSymbianApp() 
{
}

#if defined (UIQ3)
#include <gp2xpectrum.rsg>
/**
 * Returns the resource id to be used to declare the views supported by this UIQ3 app
 * @return TInt, resource id
 */
TInt CSymbianApp::ViewResourceId() {
	return R_SDL_VIEW_UI_CONFIGURATIONS;
}
#endif

/**
 *   Responsible for returning the unique UID of this application
 * @return unique UID for this application in a TUid
 **/
TUid CSymbianApp::AppDllUid() const {
	return TUid::Uid(0xA00007B1);
}

/* 
 * Minimalistic sound.c implementation for gp2x
 * (c) notaz, 2007
 */
#include <MdaAudioOutputStream.h>
#include <Mda\Common\Audio.h>

#include <e32std.h>

class CSoundOutput:public CBase ,public MMdaAudioOutputStreamCallback
{
public:
	CSoundOutput()
	{
	}

	~CSoundOutput()
	{
	delete iSndStream;
	}
#define KNoSegs  5
		// sound support
	CMdaAudioOutputStream* iSndStream;
	TMdaAudioDataSettings iAudioSettings;
	TBuf8<16384*KNoSegs> iSound[2];
	TInt iCurrentBuf;
	TInt iCurrentSeg;		
	TInt iSoundVolume; // 0-10 in 10% percent
	TInt iLastVolume;
	TInt iSampleRate;
	TInt iStereo;
	TBool UpdatePSndRate()
	{		
		TInt sampleRate = TMdaAudioDataSettings::ESampleRate8000Hz;
		if(iSampleRate == 11025)
			sampleRate = TMdaAudioDataSettings::ESampleRate11025Hz;
		else if (iSampleRate == 16000)
			sampleRate = TMdaAudioDataSettings::ESampleRate16000Hz;
		else if (iSampleRate == 22050)
			sampleRate = TMdaAudioDataSettings::ESampleRate22050Hz;
		else if (iSampleRate == 32000)
			sampleRate = TMdaAudioDataSettings::ESampleRate32000Hz;
		else if (iSampleRate == 44100)
			sampleRate = TMdaAudioDataSettings::ESampleRate44100Hz;	
		
		TRAPD(err,iSndStream->SetAudioPropertiesL(sampleRate,iStereo?TMdaAudioDataSettings::EChannelsStereo:TMdaAudioDataSettings::EChannelsMono));
		return (err == KErrNone);
	}

	void WriteSound(unsigned char* aBuffer, int bytes)
	{
		TPtrC8 ptr(aBuffer, bytes);
		TPtr8 des((unsigned char*) iSound[iCurrentBuf].Ptr()+bytes*iCurrentSeg, bytes);
		des.Copy(ptr);
		iCurrentSeg++;
		if(iCurrentSeg == KNoSegs)
		{
		iSound[iCurrentBuf].SetLength(bytes*KNoSegs);
		iSndStream->WriteL(iSound[iCurrentBuf]);
		iCurrentBuf = 1-iCurrentBuf;
		//iSound[iCurrentBuf].SetLength(0);
		iCurrentSeg = 0;
		}

	}
	
	void MaoscOpenComplete(TInt aError)
	{
		if(aError == KErrNone)
		{
			iSndStream->SetPriority(EPriorityMuchMore, EMdaPriorityPreferenceNone);
			iSndStream->SetVolume((iSndStream->MaxVolume()*iSoundVolume)/10);
			iLastVolume = iSoundVolume;
			if(!UpdatePSndRate())
			{
				iSampleRate = 8000;
				UpdatePSndRate();
			}
		}
		CActiveScheduler::Stop();
	}
	
	void MaoscBufferCopied(TInt aError, const TDesC8& aBuffer)
	{
	if(iLastVolume != iSoundVolume || aError != KErrNone)
		{
		iSndStream->SetVolume((iSndStream->MaxVolume()*iSoundVolume)/10);
		iLastVolume = iSoundVolume;
		}
	}

	void MaoscPlayComplete(TInt aError)
	{
		if(aError != KErrNone)
		{
			iSndStream->SetVolume((iSndStream->MaxVolume()*iSoundVolume)/10);
			UpdatePSndRate();
		}
	}
	
	void ConstructL()
	{
		iSoundVolume = 10;
		iSndStream = CMdaAudioOutputStream::NewL(*this);
		iAudioSettings.Query();
		iAudioSettings.iSampleRate = TMdaAudioDataSettings::ESampleRate8000Hz;
		iAudioSettings.iChannels = TMdaAudioDataSettings::EChannelsMono;
		iAudioSettings.iFlags = 0;
		iAudioSettings.iVolume = iAudioSettings.iMaxVolume/2;
		iSndStream->Open(&iAudioSettings);
		CActiveScheduler::Start(); // wait for open
	}

};

static CSoundOutput* output = NULL;
extern "C"
	{
	
void gp2x_volume(int left, int rigth)
	{
	 if(output != NULL)
		 {
		 output->iSoundVolume =left/10;
		 }
	}	

int gp2x_start_sound(int rate, int bits, int stereo)
{
	if(output != NULL)
	{
		output->iSampleRate = rate;
		output->iStereo = stereo;
		output->iSoundVolume = volume/10;
		output->UpdatePSndRate();
	}
	else
	{
		output = new (ELeave) CSoundOutput;
		output->iSampleRate = rate;
		output->iStereo = stereo;
		output->iSoundVolume = volume/10;
		output->ConstructL();
	}
	return 0;
}

// this is meant to be called only once on exit
void gp2x_stop_sound(void)
{
delete output;
output = NULL;
}

int gp2x_send_sound(void *samples,int nsamples)
{
	output->WriteSound((unsigned char*)samples, nsamples*2);
	return 1;
}
}
